local release="r201014a" --var=release: release management 
local myname="GS"
local Me=CreateFrame("Frame",myname.."code")
local widget={}
local config={}
GSdb={}
GSpc={}

-- local itemname,ilink,irare,ilevel,iminlvl, itype,isubtype, iscount, iequiploc, itemtexture, iprice=GetItemInfo(shallequip)

-- ****************************************************************************************************************
-- INITIALIZATION
-- ****************************************************************************************************************
BINDING_HEADER_GS = myname
SLASH_GS1 = "/gs"
SlashCmdList[myname]=function (cmd) Me:SlashCommand(cmd) end

Me:SetScript("OnEvent",function(this,event,arg1,arg2,arg3,arg4) Me:OnEvent(event,arg1,arg2,arg3,arg4) end)
Me:RegisterEvent("VARIABLES_LOADED")

function Me:OnEvent(event)
	if event=="VARIABLES_LOADED" then
		widget={myframe=getglobal(myname),button=getglobal(myname.."button"),config=getglobal(myname.."config")}
--GSdb=nil		
		if not GSdb or not GSdb.list then 
			GSdb={list={}} 
			Me:Nachtwache()
		end
		-- Nachtwache Raid per Default
		if not GSpc or not GSpc.pos then
			local lclass,class,_=UnitClass("player")
			GSpc={pos={myname={point="TOPLEFT",parent=nil,parentpoint="TOPLEFT",x=0,y=0}},show=(class=="WARLOCK")}
		end
--		Me:CheckMyGS() zu diesem Zeitpunkt ggf. Infos noch nicht verfügbar
		Me:setPos(widget.myframe)
		widget.button:SetNormalTexture(135230) 
		widget.button.tooltipText="Gibt im /schlachtzug die Größe der Gesundheitssteine aller (bekannten) Hexer im Raid aus.\nMit Rechtsclick wird das Konfigurationsmenü geöffnet"
		Me:ShowOrHide(GSpc.show)
		print(myname.." "..release.." initialisiert")
	end
end

function Me:Nachtwache()
	for name,size in pairs({Arcadian=1440, 
							Arkas=1200, 
							Djibali=1440, 
							Dokin=1440, 
							Gajalondrina=1320, 
							Hessa=1200, 
							Paline=1200, 
							Pulpikus=1440, 
							Silenna=1320, 
							Vastaya=1440,
							["Zifnâb"]=1440
							}) do
		GSdb.list[name]=size
		print("GS: Nachtwachenhexer "..name.." eingetragen mit "..size)
	end
end

-- ****************************************************************************************************************
-- CLICK
-- ****************************************************************************************************************
function Me:click(button,leftright)
	if leftright=="RightButton" then
		Me:config()
	else
		Me:list()
	end
end

-- ****************************************************************************************************************
-- SLASH COMMAND
-- ****************************************************************************************************************
function Me:SlashCommand(cmd)
	cmd=string.upper(cmd or "")
	if cmd=="CONFIG" then
		Me:config()
	elseif cmd=="LIST" or cmd=="" then
		Me:list()
	elseif cmd=="SHOW" then
		Me:ShowOrHide(true)
	elseif cmd=="HIDE" then
		Me:ShowOrHide(false)
	elseif cmd=="NACHTWACHE" then
		Me:Nachtwache()
	else
		print("GS: Unbekannter Befehl "..cmd)
	end
end

-- ****************************************************************************************************************
-- LIST
-- ****************************************************************************************************************
function Me:list()
	Me:CheckMyGS()
	local names={}
	local channel="RAID"
	if UnitExists("raid1") then
		for r=1,40,1 do	names=Me:checkUnit("raid"..r,names) end
	else
		names=Me:checkUnit("player",names)
		for r=1,5,1 do	names=Me:checkUnit("party"..r,names) end
		if UnitExists("party1") then channel="PARTY" else channel="PRINT" end
	end
	
	for size,namelist in pairs(names) do
		local message="Gesundheitssteine("..size..") von "..namelist
		if channel=="PRINT" then 
			print(message)
		else
			SendChatMessage(message,channel)
		end
	end
end

-- ****************************************************************************************************************
-- CHECK UNIT (FOR WARLOCK)
-- ****************************************************************************************************************
function Me:checkUnit(unit,names)
	if UnitExists(unit) then
		local lclass,class,_=UnitClass(unit)
		if class=="WARLOCK" then
			local name=UnitName(unit)
			local gssize=GSdb.list[name] or "?"
			GSdb.list[name]=gssize
			if not names[gssize] then
				names[gssize]=name
			else
				names[gssize]=names[gssize]..", "..name
			end
		end
	end
	return names
end

-- ****************************************************************************************************************
-- CONFIG
-- ****************************************************************************************************************
function Me:config()
	Me:CheckMyGS()
	if not widget.name then
		widget.release=widget.config:CreateFontString()
		widget.release:SetSize(200,20)
		widget.release:SetPoint("BOTTOMRIGHT",widget.config,"BOTTOMRIGHT",-5,5)
		widget.release:SetFontObject("GameFontNormalSmall")
		widget.release:SetJustifyH("RIGHT")
		widget.release:SetText(myname.." "..release)
		widget.namelabel=widget.config:CreateFontString()
		widget.namelabel:SetSize(200,20)
		widget.namelabel:SetPoint("TOPLEFT",widget.config,"TOPLEFT",10,-5)
		widget.namelabel:SetFontObject("GameFontNormal")
		widget.namelabel:SetJustifyH("LEFT")
		widget.namelabel:SetText("Hexer")
		widget.sizelabel=widget.config:CreateFontString()
		widget.sizelabel:SetSize(60,20)
		widget.sizelabel:SetPoint("TOPLEFT",widget.config,"TOPLEFT",220,-5)
		widget.sizelabel:SetFontObject("GameFontNormal")
		widget.sizelabel:SetJustifyH("LEFT")
		widget.sizelabel:SetText("GS-Größe")
		widget.scrollup=getglobal("GSconfig_Up")
		widget.scrolldown=getglobal("GSconfig_Down")
		widget.save=getglobal("GSconfig_Save")

		widget.name={}
		widget.size={}
		for n=1,12,1 do
			local editbox=CreateFrame("EditBox",myname.."name_"..n,widget.config,"GSedit")
			editbox:SetSize(200,20)
			editbox:SetPoint("TOPLEFT",widget.config,"TOPLEFT",10,-5-22*n) 
			editbox:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = nil})
			editbox:SetBackdropColor(0,0,0,1)
			editbox.id={column="name",n=n}
			widget.name[n]=editbox
			local editsize=CreateFrame("EditBox",myname.."size_"..n,widget.config,"GSedit")
			editsize:SetSize(60,20)
			editsize:SetPoint("TOPLEFT",widget.config,"TOPLEFT",220,-5-22*n) 
			editsize:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = nil})
			editsize:SetBackdropColor(0,0,0,1)
			editsize.id={column="size",n=n}
			widget.size[n]=editsize
		end
	end
	
	local names={}
	for name,gssize in pairs(GSdb.list) do names[#names+1]=name end
	table.sort(names)
	local sorted={}
	for sn=1,#names,1 do sorted[names[sn]]=sn end
	
	config={init=true,top=0, high=#names, savehigh=#names,list={},save={}}
	for name,gssize in pairs(GSdb.list) do
		local n=sorted[name]
		config.list[n]={name=name,size=gssize}
		config.save[n]={name=name,size=gssize}
	end
	Me:configList()
	widget.config:Show()
	config.init=false
end

-- ****************************************************************************************************************
-- CONFIG LIST
-- ****************************************************************************************************************
function Me:configList(scroll)
	config.top=config.top+(scroll or 0)
	if config.top<0 then config.top=0 end
	if config.top>0 then widget.scrollup:Show() else widget.scrollup:Hide() end
	if config.top+10<config.high then widget.scrollup:Show() else widget.scrollup:Hide() end
	for n=1,12,1 do
		cn=config.top+n
		if config.list[cn] then
			widget.name[n]:SetText(config.list[cn].name)
			widget.size[n]:SetText(config.list[cn].size)
		else
			widget.name[n]:SetText("")
			widget.size[n]:SetText("")
		end
	end
end

-- ****************************************************************************************************************
-- EDIT BOX CHANGE
-- ****************************************************************************************************************
function Me:edit(editbox, key)
	if key=="ESCAPE" then 
		widget.config:Hide()
	elseif key=="TAB" then
		if editbox.id.column=="name" then
			widget.size[editbox.id.n]:SetFocus()
		elseif editbox.id.n<12 then
			widget.name[editbox.id.n+1]:SetFocus()
		end
	elseif key=="ENTER" and editbox.id.n<12 then
		widget.name[editbox.id.n+1]:SetFocus()
	elseif key=="DOWN" and editbox.id.n<12 then
		widget[editbox.id.column][editbox.id.n+1]:SetFocus()
	elseif key=="UP" and editbox.id.n>1 then
		widget[editbox.id.column][editbox.id.n-1]:SetFocus()
	elseif not config.init then
		local n=config.top+editbox.id.n
		local name=widget.name[editbox.id.n]:GetText()
		local size=widget.size[editbox.id.n]:GetText()
		if name~="" or size~="" then
			config.list[n]={name=name,size=size}
			if n>config.high then 
				config.high=n
			end
		else
			config.list[n]=nil
			-- TODO auch davor liegende Leerentries von high abziehen
			if n==config.high then 
				config.high=config.high-1 
			end
		end
		if config.top+11<config.high then
			widget.scrolldown:Show()
		else
			widget.scrolldown:Hide()
		end
		if config.savehigh then
			local changed=false
			for n=1,max(config.high,config.savehigh),1 do
				if config.list[n] and not config.save[n] then changed=true end
				if not config.list[n] and config.save[n] then changed=true end
				if config.list[n] and config.save[n] then
					if (config.list[n].name or "")~=(config.save[n].name or "") then changed=true end
					if "x"..(config.list[n].size or "")~="x"..(config.save[n].size or "") then changed=true end
				end
			end
			if changed then widget.save:Show() else widget.save:Hide() end
		end
	end
end

-- ****************************************************************************************************************
-- SAVE CONFIG
-- ****************************************************************************************************************
function Me:save()
	local list={}
	for n=1,config.high,1 do
		if config.list[n] and config.list[n].name~="" then
			list[config.list[n].name]=config.list[n].size
		end
	end
	GSdb.list=list
	Me:closeConfig()
end

-- ****************************************************************************************************************
-- CLOSE CONFIG
-- ****************************************************************************************************************
function Me:closeConfig()
	widget.config:Hide()
end

-- ****************************************************************************************************************
-- TOOLTIP
-- ****************************************************************************************************************
function Me:toolTip(widget)
	if widget.tooltipText then
		GameTooltip:SetOwner(widget, "ANCHOR_RIGHT")
		GameTooltip:SetText(widget.tooltipText, 1.0, 0.8, 0.0, 1 )
		GameTooltip:Show();
	end
end

-- ****************************************************************************************************************
-- FRAME MOVED
-- ****************************************************************************************************************
function Me:moved(frame)
	point, parent, parentpoint, x, y = frame:GetPoint()
	GSpc.pos={point=point,parent=parent,parentpoint=parentpoint,x=x,y=y}
end

-- ****************************************************************************************************************
-- SET FRAME POSITION
-- ****************************************************************************************************************
function Me:setPos(frame)
	local pos=GSpc.pos[frame:GetName()] or {}
	frame:SetPoint(pos.point or "CENTER",pos.parent or UIParent,pos.parentpoint or "CENTER",pos.x or 0,pos.y or 0)
end

-- ****************************************************************************************************************
-- SHOW OR HIDE FRAME
-- ****************************************************************************************************************
function Me:ShowOrHide(show)
	GSpc.show=show
	if GSpc.show then 
		widget.myframe:Show()
	else
		widget.myframe:Hide()
	end
end

-- ****************************************************************************************************************
-- CHECK OWN HEALTHSTONE SIZE
-- ****************************************************************************************************************
function Me:CheckMyGS() 
	local lclass,class,_=UnitClass("player")
	if class=="WARLOCK" then
		local _,_,_,_,rank,_=GetTalentInfo(2,1)
		local size=1200+120*rank
		local player=UnitName("player")
		if not GSdb.list[player] then
			GSdb.list[player]=size
		elseif "x"..GSdb.list[player]~="x"..size then
			print("GS: Du bist eingetragen mit "..GSdb.list[player].." hast aber "..rank.." Talentpunkte auf verbesserten Gesundheitsstein vergeben (="..size..")")
		end
	end
end
